<?php

namespace TrustSpot\Lootly\Block\Adminhtml;

/**
 * TrustSpot_Lootly Adminhtml Block for Connection Test
 *
 * @category    Lootly Extensions
 * @package     TrustSpot_Lootly
 * @author      Lootly Inc
 */
class Test extends \Magento\Config\Block\System\Config\Form\Field
{

    /**
     * @var \TrustSpot\Lootly\Helper\Api
     */
    protected $orderNotifierApiHelper;
    protected $_assetRepo;

    protected $_template = 'TrustSpot_Lootly::system/config/test.phtml';

    /**
     * @var \Magento\Config\Model\ResourceModel\Config
     */
    protected $_resourceConfig;

    /**
     * @param \Magento\Backend\Block\Template\Context $context
     * @param array $data
     */
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \TrustSpot\Lootly\Helper\Api $orderNotifierApiHelper,
        \Magento\Config\Model\ResourceModel\Config $resourceConfig,
        array $data = []
    )
    {
        $this->orderNotifierApiHelper = $orderNotifierApiHelper;
        $this->_resourceConfig = $resourceConfig;
        $this->_assetRepo = $context->getAssetRepository();
        parent::__construct($context, $data);
    }

    /*public function __construct(
        \TrustSpot\Lootly\Helper\Api $orderNotifierApiHelper,
        \Magento\Config\Model\ResourceModel\Config $resourceConfig,
        \Magento\Framework\View\Asset\Repository $_assetRepo
    ) {
        $this->orderNotifierApiHelper = $orderNotifierApiHelper;
        $this->_resourceConfig = $resourceConfig;
        $this->_assetRepo = $_assetRepo;
    }*/


    /**
     * Remove scope label
     *
     * @param  \Magento\Framework\Data\Form\Element\AbstractElement $element
     * @return string
     */
    public function render(\Magento\Framework\Data\Form\Element\AbstractElement $element)
    {
        $element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();
        return parent::render($element);
    }

    /**
     * Prepares Top HTML for Lootly Settings page
     *
     * @access protected
     * @author Lootly Inc
     */
    protected function _getElementHtml(\Magento\Framework\Data\Form\Element\AbstractElement $element)
    {
        return $this->_toHtml();
    }

    public function getSignupUrl()
    {
        $signupURL = \TrustSpot\Lootly\Helper\Data::SIGNUP_URL;

        return $signupURL;
    }

    public function getLoginUrl()
    {
        $loginURL = \TrustSpot\Lootly\Helper\Data::LOGIN_URL;

        return $loginURL;
    }

    public function checkVerify()
    {
        $_helper = $this->orderNotifierApiHelper;

        if ($merchantId = $_helper->verify()) {
            $this->_resourceConfig->saveConfig(
                'lootlyordernotifier/general/merchant_id',
                $merchantId,
                'default',
                0
            );
            return true;
        } else {
            return false;
        }
    }
}
