<?php

namespace TrustSpot\Lootly\Block;

use Magento\Framework\View\Element\Template;

/**
 * TrustSpot_Lootly Adminhtml Block for Verify Settings
 *
 * @category    Lootly Extensions
 * @package     trustspot_lootly
 * @author      Lootly Inc
 */
class Widget extends \Magento\Framework\View\Element\Template
{
    public function getStoreId()
    {
        return $this->_storeManager->getStore()->getId();
    }
    public function getConfigValue($code)
    {
        $scope = 'default';
        $storeId = $this->getStoreId();
        if ($storeId > 0) {
            $scope = 'store';
        }
        return $this->_scopeConfig->getValue($code, $scope, $storeId);
    }

    public function getApiKey()
    {

        return $this->getConfigValue('lootlyordernotifier/general/api_key');
    }

    public function getApiSecret()
    {
        return $this->getConfigValue('lootlyordernotifier/general/api_secret');
    }

    public function getCustomerId()
    {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $_session = $objectManager->get('\Magento\Customer\Model\Session');
        return $_session->getCustomerId();
    }

    public function getCustomerSignature()
    {
        $customerId = $this->getCustomerId();
        $secret = $this->getApiSecret();

        $customerSignature = $this->getHash($customerId . $secret);
        return $customerSignature;
    }

    public function getHash($string)
    {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $MD5Source = $objectManager->get('\TrustSpot\Lootly\Helper\MD5Source');
        $hash = $MD5Source->md($string);
        return $hash;
    }
}
