<?php
/**
 * TrustSpot_Lootly extension
 * @category       Lootly Extensions
 * @package        TrustSpot_Lootly
 * @copyright      Copyright (c) 2015
 * @license        http://opensource.org/licenses/osl-3.0.php Open Software License (OSL 3.0)
 */

namespace TrustSpot\Lootly\Model;


class Entry extends \Magento\Framework\Model\AbstractModel
{
    const ENTRY_ID = 'entry_id';
    const ORDER_ID = 'order_id';

    protected function _construct()
    {
        $this->_init('TrustSpot\Lootly\Model\ResourceModel\Entry');
    }

    /**
     * Get entry_id
     * @return string
     */
    public function getEntryId()
    {
        return $this->getData(self::ENTRY_ID);
    }

    /**
     * Set entry_id
     * @param string $entryId
     * @return
     */
    public function setEntryId($entryId)
    {
        return $this->setData(self::ENTRY_ID, $entryId);
    }

    /**
     * Get order_id
     * @return string
     */
    public function getOrderId()
    {
        return $this->getData(self::ORDER_ID);
    }

    /**
     * Set order_id
     * @param string $order_id
     * @return
     */
    public function setOrderId($order_id)
    {
        return $this->setData(self::ORDER_ID, $order_id);
    }
}
