<?php

/**
 * TrustSpot_Lootly extension
 * @category       Lootly Extensions
 * @package        TrustSpot_Lootly
 * @copyright      Copyright (c) 2015
 * @license        http://opensource.org/licenses/osl-3.0.php Open Software License (OSL 3.0)
 */

namespace TrustSpot\Lootly\Observer;

class SalesOrderInvoiceSaveAfter implements \Magento\Framework\Event\ObserverInterface
{
    /**
     * @var \TrustSpot\Lootly\Helper\Data
     */
    protected $orderNotifierHelper;

    /**
     * @var \TrustSpot\Lootly\Helper\Api
     */
    protected $orderNotifierApiHelper;

    public function __construct(
        \TrustSpot\Lootly\Helper\Data $orderNotifierHelper,
        \TrustSpot\Lootly\Helper\Api $orderNotifierApiHelper
    )
    {
        $this->orderNotifierHelper = $orderNotifierHelper;
        $this->orderNotifierApiHelper = $orderNotifierApiHelper;
    }

    public function execute(
        \Magento\Framework\Event\Observer $observer
    )
    {
        $invoiceId = $observer->getEvent()->getInvoice()->getOrigData('entity_id');
        if ($invoiceId === null) {
            $order = $observer->getEvent()->getInvoice()->getOrder();
            $storeId = $order->getStoreId();
            $targetStatus = $this->orderNotifierApiHelper->getTargetOrderStatus($storeId);
            if ($targetStatus != '' && $targetStatus == 'invoiced') {
                $this->orderNotifierApiHelper->sendToApi($order, $targetStatus);
            }
        }

        return $this;
    }
}
